﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Data;
using Infragistics.Controls.Interactions;
using Infragistics.Controls.Grids.Primitives;
using Infragistics.Windows;
using System.Collections;
using System.Globalization;
using System.Collections.ObjectModel;
using Infragistics.Controls.Grids;
using System.ComponentModel;

namespace XamGridDateColumn
{
    /// <summary>
    /// Interaction logic for AdvancedDateConfiguration.xaml
    /// </summary>
    public partial class DateConfig : XamDialogWindow
    {

        #region "Variables"

        DataTable _dtAdvDateConfig;
        DataTable _dtAdvPeriodConfig;       //Holds the data for the Advanced Period Configurations
        bool isRecursive = false;
        bool EditingCanceled = false;
        DateTime? previousSelectedDate = null;
        bool IsPagingCancel = false;
       
        #endregion

        #region "Constructor"

        public DateConfig()
        {
            InitializeComponent();
        }

        #endregion

        #region "Event Handlers"

        private void XamDialogWindow_WindowStateChanged(object sender, WindowStateChangedEventArgs e)
        {

        }

        private void XamDialogWindow_Loaded(object sender, RoutedEventArgs e)
        {
            
            //AdvDateConfigs.ItemsSource = _dtAdvDateConfig.DefaultView;
            _dtAdvPeriodConfig = new DataTable();
            _dtAdvPeriodConfig.Columns.Add("FiscalPeriod");
            _dtAdvPeriodConfig.Columns.Add("Label");
            _dtAdvPeriodConfig.Columns.Add("StartDate",typeof(DateTime));
            _dtAdvPeriodConfig.Columns.Add("EndDate",typeof(DateTime));


            DateTime objStartDate = Convert.ToDateTime("01/01/2013");

            _dtAdvPeriodConfig.Rows.Add("201301", "January", objStartDate, objStartDate.AddMonths(1).AddDays(-1));
            _dtAdvPeriodConfig.Rows.Add("201302", "Feb", objStartDate.AddMonths(1), objStartDate.AddMonths(2).AddDays(-1));
            _dtAdvPeriodConfig.Rows.Add("201303", "March", objStartDate.AddMonths(2), objStartDate.AddMonths(3).AddDays(-1));            

            AdvDateConfigs.ItemsSource = _dtAdvPeriodConfig.DefaultView;
        }

        private void btnCancel_Click(object sender, RoutedEventArgs e)
        {

        }

        private void btnNext_Click(object sender, RoutedEventArgs e)
        {
        }
        #endregion


        private void AdvDateConfigs_ActiveCellChanged(object sender, EventArgs e)
        {
            //ActiveRowIndex = -1;
            //ActiveColumnName = string.Empty;
            if (AdvDateConfigs.ActiveCell != null)
            {
                if (AdvDateConfigs.ActiveCell.Column.Key == "FiscalPeriod")
                {
                    //AdvDateConfigs.ActiveCell.Row.Cells["StartDate"].IsSelected = true;
                    //AdvDateConfigs.ActiveCell.Row.Cells["StartDate"].IsActive = true;
                    //////AdvDateConfigs.ExitEditMode(true);
                    ////AdvDateConfigs.EnterEditMode();
                }
                else if (AdvDateConfigs.ActiveCell.Column.Key == "StartDate")
                {
                    previousSelectedDate = Convert.ToDateTime(AdvDateConfigs.ActiveCell.Row.Cells["StartDate"].Value);

                    //ActiveRowIndex  = AdvDateConfigs.ActiveCell.Row.Index;
                    //ActiveColumnName = AdvDateConfigs.ActiveCell.Column.Key;
                    ////ActiveCellIndex = AdvDateConfigs.ActiveCell.index ;

                    //if (ActiveRowIndex <= 0)
                    //    PreviousStartDate = null;                        
                    //else
                    //    PreviousStartDate = Convert.ToDateTime(AdvDateConfigs.Rows[ActiveRowIndex - 1].Cells["StartDate"].Value);

                    AdvDateConfigs.EnterEditMode(this.AdvDateConfigs.ActiveCell);

                    ////AdvDateConfigs.EnterEditMode();
                }
                else if (AdvDateConfigs.ActiveCell.Column.Key == "Label")
                    AdvDateConfigs.EnterEditMode(this.AdvDateConfigs.ActiveCell);
            }
        }

        private void AdvDateConfigs_CellClicked(object sender, CellClickedEventArgs e)
        {
            //if (e.Cell.Column.Key == "FiscalPeriod" || e.Cell.Column.Key == "Label")
            //{
            //    e.Cell.IsSelected = false;
            //    e.Cell.IsActive = false;
            //}               
        }

        private void AdvDateConfigs_CellEnteringEditMode(object sender, BeginEditingCellEventArgs e)
        {                    
            if (e.Cell.Column.Key == "StartDate")
            {
                e.Cell.Row.Cells["StartDate"].IsSelected = true;
                e.Cell.Row.Cells["StartDate"].IsActive = true;
            }            
        }

        private void DatePicker_PreviewKeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Escape)
                EditingCanceled = true;
        }    

        private void AdvDateConfigs_CellExitingEditMode(object sender, Infragistics.Controls.Grids.ExitEditingCellEventArgs e)
        {
            DateTime t;
            Boolean IsValueNeedToUpdate = true;

            if (isRecursive == true)
            {
                //e.Cancel = true;
                return;
            }
            if (EditingCanceled == false)
            {
                if (e.Cell.Column.Key == "StartDate" && (e.Editor as DatePicker).Text.Trim() != string.Empty && DateTime.TryParse((e.Editor as DatePicker).Text.Trim(), out t)) //DateTime.TryParse(e.Editor.ToString(), out t))
                {
                    if (Convert.ToDateTime(Helper.GetParsedDate((e.Editor as DatePicker).Text, DateFormat.MonthDateYear), CultureInfo.InvariantCulture) > Convert.ToDateTime(Helper.GetParsedDate(Convert.ToString(e.Cell.Row.Cells["EndDate"].Value, CultureInfo.CurrentCulture), DateFormat.MonthDateYear), CultureInfo.InvariantCulture))
                    {
                        //if (e.Cell.IsActive == true)
                        //{                            
                        //Dispatcher.BeginInvoke(new Action(() =>
                        //{
                        //e.NewValue= Convert.ToDateTime(Helper.GetParsedDate(Convert.ToString(e.Cell.Value, CultureInfo.CurrentCulture), DateFormat.MonthDateYear), CultureInfo.InvariantCulture);
                        //    (e.Editor as DatePicker).DisplayDate = Convert.ToDateTime(Helper.GetParsedDate(Convert.ToString(e.Cell.Value, CultureInfo.CurrentCulture), DateFormat.MonthDateYear), CultureInfo.InvariantCulture);                                                             
                        //}));

                        //e.Cancel = true;
                        //Dispatcher.BeginInvoke(new Action(() =>
                        //{

                        //isRecursive = true;
                        //AdvDateConfigs.ExitEditMode(true);
                        //isRecursive = false;

                        //e.Cell.IsActive = true;
                        //e.Cell.IsSelected = true;
                        //}));

                        MessageBox.Show("Start of period cannot be greater than end of period of same fiscal period.", "Date Configuration.", MessageBoxButton.OK, MessageBoxImage.Exclamation);

                        e.NewValue = previousSelectedDate;
                        (e.Editor as DatePicker).SelectedDate = previousSelectedDate;//Convert.ToDateTime(Helper.GetParsedDate(Convert.ToString(e.Cell.Value, CultureInfo.CurrentCulture), DateFormat.MonthDateYear), CultureInfo.InvariantCulture);
                        (e.Editor as DatePicker).DisplayDate = Convert.ToDateTime(previousSelectedDate);
                        (e.Editor as DatePicker).Text = Convert.ToString(previousSelectedDate);


                        //e.Cell.IsActive = true;
                        //e.Cell.IsSelected = true;     
                        //e.Cancel = true;
                        //(e.Editor as DatePicker).Text = Convert.ToString(e.NewValue);
                        //(e.Editor as DatePicker).SelectedDate = Convert.ToDateTime(e.NewValue);     

                        //System.Windows.Forms.Application.DoEvents();                                                                               

                        IsPagingCancel = true;
                        IsValueNeedToUpdate = false;
                        //}
                    }
                    else
                    {
                        int prevIndex = ((e.Cell.Row.Index - 1) + (AdvDateConfigs.PagerSettings.CurrentPageIndex - 1) * AdvDateConfigs.PagerSettings.PageSize); //VitheshTemp
                        //if ((AdvDateConfigs.PagerSettings.CurrentPageIndex - 1) == _noneditablePageEnd + 1 && e.Cell.Row.Index == 0 && e.Cell.Column.Key == "StartDate")
                        //{
                        //    e.Cancel = true;
                        //    Dispatcher.BeginInvoke(new Action(() =>
                        //    {
                        //        (e.Editor as DatePicker).SelectedDate = Convert.ToDateTime(e.Cell.Value);
                        //        (e.Editor as DatePicker).DisplayDate = Convert.ToDateTime(e.Cell.Value);
                        //   e.Cell.IsActive = true;
                        //        e.Cell.IsSelected = true;
                        //    }));
                        //    MessageBox.Show("Cannot edit the start of period for first period for newly added year.", "Date Configuration.", MessageBoxButton.OK, MessageBoxImage.Exclamation);
                        //}
                        if (prevIndex >= 0)
                        {
                            if (Convert.ToDateTime(Helper.GetParsedDate((e.Editor as DatePicker).Text, DateFormat.MonthDateYear), CultureInfo.InvariantCulture) <= Convert.ToDateTime(Helper.GetParsedDate(_dtAdvPeriodConfig.Rows[prevIndex]["StartDate"].ToString(), DateFormat.MonthDateYear), CultureInfo.InvariantCulture))
                            {
                                if (e.Cell.IsActive == true)
                                {
                                    //e.Cancel = true;

                                    //Dispatcher.BeginInvoke(new Action(() =>
                                    //{                                                                                                                                                           
                                    //    (e.Editor as DatePicker).SelectedDate = Convert.ToDateTime(Helper.GetParsedDate(Convert.ToString(e.Cell.Value, CultureInfo.CurrentCulture), DateFormat.MonthDateYear), CultureInfo.InvariantCulture);
                                    //    (e.Editor as DatePicker).DisplayDate = Convert.ToDateTime(Helper.GetParsedDate(Convert.ToString(e.Cell.Value, CultureInfo.CurrentCulture), DateFormat.MonthDateYear), CultureInfo.InvariantCulture);                                                                        
                                    //}));

                                    MessageBox.Show("Start of period cannot be less than start period of previous fiscal period.", "Date Configuration.", MessageBoxButton.OK, MessageBoxImage.Exclamation);

                                    e.NewValue = previousSelectedDate;
                                    (e.Editor as DatePicker).SelectedDate = previousSelectedDate;//Convert.ToDateTime(Helper.GetParsedDate(Convert.ToString(e.Cell.Value, CultureInfo.CurrentCulture), DateFormat.MonthDateYear), CultureInfo.InvariantCulture);
                                    (e.Editor as DatePicker).DisplayDate = Convert.ToDateTime(previousSelectedDate);
                                    (e.Editor as DatePicker).Text = Convert.ToString(previousSelectedDate);

                                    IsPagingCancel = true;
                                    IsValueNeedToUpdate = false;
                                }
                            }
                        }
                    }
                }
                else if (e.Cell.Column.Key == "EndDate" && (e.Editor as DatePicker).Text.Trim() != string.Empty)
                {
                    if (Convert.ToDateTime(Helper.GetParsedDate((e.Editor as DatePicker).Text, DateFormat.MonthDateYear), CultureInfo.InvariantCulture) < Convert.ToDateTime(Helper.GetParsedDate(Convert.ToString(e.Cell.Row.Cells["StartDate"].Value, CultureInfo.CurrentCulture), DateFormat.MonthDateYear), CultureInfo.InvariantCulture))
                    {
                        if (e.Cell.IsActive == true)
                        {
                            //Dispatcher.BeginInvoke(new Action(() =>
                            //{
                            //    (e.Editor as DatePicker).SelectedDate = Convert.ToDateTime(Helper.GetParsedDate(Convert.ToString(e.Cell.Value, CultureInfo.CurrentCulture), DateFormat.MonthDateYear), CultureInfo.InvariantCulture);
                            //    (e.Editor as DatePicker).DisplayDate = Convert.ToDateTime(Helper.GetParsedDate(Convert.ToString(e.Cell.Value, CultureInfo.CurrentCulture), DateFormat.MonthDateYear), CultureInfo.InvariantCulture);                                                            
                            //}));

                            MessageBox.Show("End of period cannot be less than start of period of same fiscal period.", "Date Configuration.", MessageBoxButton.OK, MessageBoxImage.Exclamation);
                            System.Windows.Forms.Application.DoEvents();

                            e.Cell.IsSelected = true;
                            e.Cell.IsActive = true;

                            IsPagingCancel = true;
                            IsValueNeedToUpdate = false;
                        }
                    }
                }
                else if (e.Cell.Column.Key == "Label")
                {
                    IsValueNeedToUpdate = false;

                    if ((e.Editor as TextBox).Text.Trim() == string.Empty)
                    //if (e.NewValue.ToString().Trim() == string.Empty)
                    {
                        MessageBox.Show("Label cannot be blank.", "Date Configuration.", MessageBoxButton.OK, MessageBoxImage.Exclamation);
                        IsPagingCancel = true;
                        e.Cancel = true;
                    }
                }
                if (IsValueNeedToUpdate == true && e.Cell.IsSelected == true && (e.Editor as DatePicker).Text.Trim() != string.Empty && DateTime.TryParse((e.Editor as DatePicker).Text.Trim(), out t))
                {
                    e.NewValue = Convert.ToDateTime(Helper.GetParsedDate((e.Editor as DatePicker).Text, DateFormat.MonthDateYear), CultureInfo.InvariantCulture);
                    CellExistedEditMode(e.Cell.Row.Index, e.Cell.Column.Key, (e.Editor as DatePicker).Text);
                    IsPagingCancel = false;
                }

            }
            else //e.EditingCanceled ==true
            {
                e.Cancel = true;
                isRecursive = true;
                //AdvDateConfigs.ExitEditMode(true);
                (e.Editor as DatePicker).Text = Convert.ToString(previousSelectedDate); //e.NewValue
                (e.Editor as DatePicker).SelectedDate = previousSelectedDate;//Convert.ToDateTime(e.NewValue);                
                (e.Editor as DatePicker).UpdateLayout();
                //Dispatcher.BeginInvoke(new Action(() =>
                //           {                               
                //               e.Cell.IsSelected = true;
                //               e.Cell.IsActive = true;                               
                //}));


                //e.NewValue = e.Cell.Value;
                IsPagingCancel = true;
                isRecursive = false;
            }

            EditingCanceled = false;
            UpdateLayout();









            //DateTime t;
            //Boolean IsValueNeedToUpdate = true;

            //if (isRecursive == true) return;

            //if (e.EditingCanceled == false)
            //{
            //    if (e.Cell.Column.Key == "StartDate" && (e.Editor as DatePicker).Text.Trim() != string.Empty && DateTime.TryParse((e.Editor as DatePicker).Text.Trim(), out t)) //DateTime.TryParse(e.Editor.ToString(), out t))
            //    {
            //        if (Convert.ToDateTime(Helper.GetParsedDate((e.Editor as DatePicker).Text, DateFormat.MonthDateYear), CultureInfo.InvariantCulture) > Convert.ToDateTime(Helper.GetParsedDate(Convert.ToString(e.Cell.Row.Cells["EndDate"].Value, CultureInfo.CurrentCulture), DateFormat.MonthDateYear), CultureInfo.InvariantCulture))
            //        {
            //            e.Cancel = true;

            //            if (e.Cell.IsSelected == true)
            //            {
            //            //Dispatcher.BeginInvoke(new Action(() =>
            //            //{
            //            //e.NewValue= Convert.ToDateTime(Helper.GetParsedDate(Convert.ToString(e.Cell.Value, CultureInfo.CurrentCulture), DateFormat.MonthDateYear), CultureInfo.InvariantCulture);
            //            //    (e.Editor as DatePicker).DisplayDate = Convert.ToDateTime(Helper.GetParsedDate(Convert.ToString(e.Cell.Value, CultureInfo.CurrentCulture), DateFormat.MonthDateYear), CultureInfo.InvariantCulture);
            //            e.Cell.IsActive = true;
            //            //e.Cell.IsSelected = true;
            //            //}));

            //                MessageBox.Show("Start of period cannot be greater than end of period of same fiscal period.", "Date Configuration.", MessageBoxButton.OK, MessageBoxImage.Exclamation);
            //                IsValueNeedToUpdate = false;
            //            }
            //        }
            //        else
            //        {
            //            int prevIndex = ((e.Cell.Row.Index - 1) + (AdvDateConfigs.PagerSettings.CurrentPageIndex - 1) * AdvDateConfigs.PagerSettings.PageSize); //VitheshTemp
            //            //if ((AdvDateConfigs.PagerSettings.CurrentPageIndex - 1) == _noneditablePageEnd + 1 && e.Cell.Row.Index == 0 && e.Cell.Column.Key == "StartDate")
            //            //{
            //            //    e.Cancel = true;
            //            //    Dispatcher.BeginInvoke(new Action(() =>
            //            //    {
            //            //        (e.Editor as DatePicker).SelectedDate = Convert.ToDateTime(e.Cell.Value);
            //            //        (e.Editor as DatePicker).DisplayDate = Convert.ToDateTime(e.Cell.Value);
            //            //        e.Cell.IsActive = true;
            //            //        e.Cell.IsSelected = true;
            //            //    }));
            //            //    MessageBox.Show("Cannot edit the start of period for first period for newly added year.", "Date Configuration.", MessageBoxButton.OK, MessageBoxImage.Exclamation);
            //            //}
            //            if (prevIndex >= 0)
            //            {
            //                if (Convert.ToDateTime(Helper.GetParsedDate((e.Editor as DatePicker).Text, DateFormat.MonthDateYear), CultureInfo.InvariantCulture) <= Convert.ToDateTime(Helper.GetParsedDate(_dtAdvPeriodConfig.Rows[prevIndex]["StartDate"].ToString(), DateFormat.MonthDateYear), CultureInfo.InvariantCulture))
            //                {
            //                    e.Cancel = true;
            //                    Dispatcher.BeginInvoke(new Action(() =>
            //                    {
            //                        (e.Editor as DatePicker).SelectedDate = Convert.ToDateTime(Helper.GetParsedDate(Convert.ToString(e.Cell.Value, CultureInfo.CurrentCulture), DateFormat.MonthDateYear), CultureInfo.InvariantCulture);
            //                        (e.Editor as DatePicker).DisplayDate = Convert.ToDateTime(Helper.GetParsedDate(Convert.ToString(e.Cell.Value, CultureInfo.CurrentCulture), DateFormat.MonthDateYear), CultureInfo.InvariantCulture);
            //                        e.Cell.IsActive = true;
            //                        e.Cell.IsSelected = true;
            //                    }));
            //                    if (e.Cell.IsSelected == true)
            //                    {
            //                        MessageBox.Show("Start of period cannot be less than start period of previous fiscal period.", "Date Configuration.", MessageBoxButton.OK, MessageBoxImage.Exclamation);
            //                        IsValueNeedToUpdate = false;
            //                    }
            //                }
            //            }
            //        }
            //    }
            //    else if (e.Cell.Column.Key == "EndDate" && (e.Editor as DatePicker).Text.Trim() != string.Empty)
            //    {
            //        if (Convert.ToDateTime(Helper.GetParsedDate((e.Editor as DatePicker).Text, DateFormat.MonthDateYear), CultureInfo.InvariantCulture) < Convert.ToDateTime(Helper.GetParsedDate(Convert.ToString(e.Cell.Row.Cells["StartDate"].Value, CultureInfo.CurrentCulture), DateFormat.MonthDateYear), CultureInfo.InvariantCulture))
            //        {
            //            e.Cancel = true;
            //            Dispatcher.BeginInvoke(new Action(() =>
            //            {
            //                (e.Editor as DatePicker).SelectedDate = Convert.ToDateTime(Helper.GetParsedDate(Convert.ToString(e.Cell.Value, CultureInfo.CurrentCulture), DateFormat.MonthDateYear), CultureInfo.InvariantCulture);
            //                (e.Editor as DatePicker).DisplayDate = Convert.ToDateTime(Helper.GetParsedDate(Convert.ToString(e.Cell.Value, CultureInfo.CurrentCulture), DateFormat.MonthDateYear), CultureInfo.InvariantCulture);
            //                e.Cell.IsActive = true;
            //                e.Cell.IsSelected = true;
            //            }));
            //            if (e.Cell.IsSelected == true)
            //            {
            //                MessageBox.Show("End of period cannot be less than start of period of same fiscal period.", "Date Configuration.", MessageBoxButton.OK, MessageBoxImage.Exclamation);
            //                IsValueNeedToUpdate = false;
            //            }
            //        }
            //    }
            //    else if (e.Cell.Column.Key == "Label")
            //    {
            //        IsValueNeedToUpdate = false;

            //        if ((e.Editor as TextBox).Text.Trim() == string.Empty)
            //        //if (e.NewValue.ToString().Trim() == string.Empty)
            //        {
            //            MessageBox.Show("Label cannot be blank.", "Date Configuration.", MessageBoxButton.OK, MessageBoxImage.Exclamation);
            //            e.Cancel = true;
            //            //Dispatcher.BeginInvoke(new Action(() =>
            //            //{                        
            //            //    e.Cell.IsActive = true;
            //            //    e.Cell.IsSelected = true;
            //            //}));                    
            //        }
            //    }
            //    //else
            //    //{
            //    //    e.Cancel = true;
            //    //    Dispatcher.BeginInvoke(new Action(() =>
            //    //    {
            //    //        (e.Editor as DatePicker).SelectedDate = Convert.ToDateTime(Helper.GetParsedDate(Convert.ToString(e.Cell.Value, CultureInfo.CurrentCulture), DateFormat.MonthDateYear), CultureInfo.InvariantCulture);
            //    //        (e.Editor as DatePicker).DisplayDate = Convert.ToDateTime(Helper.GetParsedDate(Convert.ToString(e.Cell.Value, CultureInfo.CurrentCulture), DateFormat.MonthDateYear), CultureInfo.InvariantCulture);
            //    //        e.Cell.IsActive = true;
            //    //        e.Cell.IsSelected = true;
            //    //    }));
            //    //}

            //    if (IsValueNeedToUpdate == true && e.Cell.IsSelected == true && (e.Editor as DatePicker).Text.Trim() != string.Empty && DateTime.TryParse((e.Editor as DatePicker).Text.Trim(), out t))
            //    {
            //        e.NewValue = Convert.ToDateTime(Helper.GetParsedDate((e.Editor as DatePicker).Text, DateFormat.MonthDateYear), CultureInfo.InvariantCulture);
            //        e.NewValue = Convert.ToDateTime(Helper.GetParsedDate((e.Editor as DatePicker).Text, DateFormat.MonthDateYear), CultureInfo.InvariantCulture);

            //        CellExistedEditMode(e.Cell.Row.Index, e.Cell.Column.Key, (e.Editor as DatePicker).Text);
            //    }

            //}
            //else //e.EditingCanceled ==true
            //{
            //    e.Cancel = true;
            //    isRecursive = true;
            //    AdvDateConfigs.ExitEditMode(true);                
            //    e.Cell.IsActive = true;
            //    e.Cell.IsSelected = true;
            //    AdvDateConfigs.EnterEditMode();
            //    isRecursive = false;

            //    //(e.Editor as DatePicker).Text = Convert.ToString(e.Cell.Value);
            //}

            ////else
            ////{
            ////    Dispatcher.BeginInvoke(new Action(() =>
            ////    {
            ////        (e.Editor as DatePicker).SelectedDate = Convert.ToDateTime(e.Editor);
            ////        (e.Editor as DatePicker).DisplayDate = Convert.ToDateTime(e.Editor);
            ////    }));
            ////}
            //////VitheshTemp =====================================================
            //////else
            //////{
            //////    e.Cancel = true;
            //////    Dispatcher.BeginInvoke(new Action(() =>
            //////    {
            //////        (e.Editor as DatePicker).SelectedDate = Convert.ToDateTime(Helper.GetParsedDate(Convert.ToString(e.Cell.Value, CultureInfo.CurrentCulture), DateFormat.MonthDateYear), CultureInfo.InvariantCulture);
            //////        (e.Editor as DatePicker).DisplayDate = Convert.ToDateTime(Helper.GetParsedDate(Convert.ToString(e.Cell.Value, CultureInfo.CurrentCulture), DateFormat.MonthDateYear), CultureInfo.InvariantCulture);
            //////        e.Cell.IsActive = true;
            //////        e.Cell.IsSelected = true;
            //////    }));
            //////}
            //////=================================================================
            //UpdateLayout();
        }

        private void AdvDateConfigs_CellExitedEditMode(object sender, Infragistics.Controls.Grids.CellExitedEditingEventArgs e)
        {
            //CellExistedEditMode(e.Cell.Row.Index, e.Cell.Column.Key, Convert.ToString(e.Cell.Value), Convert.ToString(e.Cell.Value));
            //CellExistedEditMode(e.Cell.Row.Index, e.Cell.Column.Key, Convert.ToString(e.Cell.Value));
            
            AdvDateConfigs.ExitEditMode(true);
            previousSelectedDate = null;

            //if (ActiveRowIndex != -1)
            //{                
            //    AdvDateConfigs.Rows[ActiveRowIndex].Cells["StartDate"].IsActive = true;
            //    AdvDateConfigs.Rows[ActiveRowIndex].Cells["StartDate"].IsSelected = true;
            //    AdvDateConfigs.EnterEditMode();
            //    ActiveRowIndex = -1;
            //}

        }

        private void AdvDateConfigs_PageIndexChanged(object sender, Infragistics.Controls.Grids.PageChangedEventArgs e)
        {
            if (AdvDateConfigs.ActiveCell != null)
            {
                AdvDateConfigs.ActiveCell.IsSelected = false;
                AdvDateConfigs.ActiveCell.IsActive = false;
            }
            //if (AdvDateConfigs.PagerSettings.CurrentPageIndex == 1)
            //{
            //    btnCopyDates.IsEnabled = false;
            //}
            //else
            //{
            //    btnCopyDates.IsEnabled = true;
            //}
            ////AdvDateConfigs.ExitEditMode(false);
            ////AdvDateConfigs.ExitEditMode(true);
        }

        private void AdvDateConfigs_PageIndexChanging(object sender, Infragistics.Controls.Grids.CancellablePageChangingEventArgs e)
        {
            if (IsPagingCancel == true)
                e.Cancel = true;
            IsPagingCancel = false;
        }

        private void CellExistedEditMode(int currentRowIndex, string columnName, string value)
        {
            int rowIndex = ((currentRowIndex + 1) + (AdvDateConfigs.PagerSettings.CurrentPageIndex - 1) * AdvDateConfigs.PagerSettings.PageSize);
            int prevIndex = ((currentRowIndex - 1) + (AdvDateConfigs.PagerSettings.CurrentPageIndex - 1) * AdvDateConfigs.PagerSettings.PageSize);

            if (columnName == "EndDate")
            {
                if (rowIndex < _dtAdvPeriodConfig.Rows.Count)
                {
                    if (Convert.ToDateTime(Helper.GetParsedDate(_dtAdvPeriodConfig.Rows[rowIndex]["StartDate"].ToString(), DateFormat.MonthDateYear), CultureInfo.InvariantCulture) <= Convert.ToDateTime(Helper.GetParsedDate(value, DateFormat.MonthDateYear), CultureInfo.InvariantCulture))
                    {
                        _dtAdvPeriodConfig.Rows[rowIndex]["StartDate"] = Convert.ToDateTime(Helper.GetParsedDate(Convert.ToString(value, CultureInfo.CurrentCulture), DateFormat.MonthDateYear), CultureInfo.InvariantCulture).AddDays(1);

                        for (int i = rowIndex; i < _dtAdvPeriodConfig.Rows.Count; i++)
                        {
                            if (Convert.ToDateTime(Helper.GetParsedDate(_dtAdvPeriodConfig.Rows[i]["StartDate"].ToString(), DateFormat.MonthDateYear), CultureInfo.InvariantCulture) > Convert.ToDateTime(Helper.GetParsedDate(_dtAdvPeriodConfig.Rows[i]["EndDate"].ToString(), DateFormat.MonthDateYear), CultureInfo.InvariantCulture))
                            {
                                _dtAdvPeriodConfig.Rows[i]["EndDate"] = Convert.ToDateTime(Helper.GetParsedDate(_dtAdvPeriodConfig.Rows[i]["StartDate"].ToString(), DateFormat.MonthDateYear), CultureInfo.InvariantCulture).AddDays(1);
                            }
                            if ((i + 1) < _dtAdvPeriodConfig.Rows.Count)
                            {
                                if (Convert.ToDateTime(Helper.GetParsedDate(_dtAdvPeriodConfig.Rows[i + 1]["StartDate"].ToString(), DateFormat.MonthDateYear), CultureInfo.InvariantCulture) < Convert.ToDateTime(Helper.GetParsedDate(_dtAdvPeriodConfig.Rows[i]["EndDate"].ToString(), DateFormat.MonthDateYear), CultureInfo.InvariantCulture))
                                {
                                    _dtAdvPeriodConfig.Rows[i + 1]["StartDate"] = Convert.ToDateTime(Helper.GetParsedDate(_dtAdvPeriodConfig.Rows[i]["EndDate"].ToString(), DateFormat.MonthDateYear), CultureInfo.InvariantCulture).AddDays(1);
                                    //if (i != (_noneditablePageStart * 12) - 1)
                                    //{
                                    //    _dtAdvancedConfig.Rows[i + 1]["StartDate"] = Convert.ToDateTime(_dtAdvancedConfig.Rows[i]["EndDate"].ToString()).AddDays(1);
                                    //}
                                    //else
                                    //{
                                    //    MessageBox.Show("Cannot edit period as the fiscal period already saved is affected by the change.","Date Configuration.", MessageBoxButton.OK, MessageBoxImage.Exclamation);
                                    //    _dtAdvancedConfig = _dtAdvConfigTemp;
                                    //    AdvDateConfigs.ItemsSource = _dtAdvancedConfig.DefaultView;
                                    //    break;
                                    //}
                                }
                            }
                        }

                        UpdateLayout();
                    }
                    else if (Convert.ToDateTime(Helper.GetParsedDate(_dtAdvPeriodConfig.Rows[rowIndex]["StartDate"].ToString(), DateFormat.MonthDateYear), CultureInfo.InvariantCulture) > Convert.ToDateTime(Helper.GetParsedDate(value, DateFormat.MonthDateYear), CultureInfo.InvariantCulture).AddDays(1))
                    {
                        _dtAdvPeriodConfig.Rows[rowIndex]["StartDate"] = Convert.ToDateTime(Helper.GetParsedDate(value, DateFormat.MonthDateYear), CultureInfo.InvariantCulture).AddDays(1);
                        UpdateLayout();
                    }
                }
                //else if (prevIndex >= 0)
                //{
                //    //for (int i = prevIndex; i >= 0; i--)
                //    //{

                //    //}

                //    //(Infragistics.Controls.Grids.RowCollection)AdvDateConfigs.Rows

                //    //(((Infragistics.Controls.Grids.RowCollection)AdvDateConfigs.Rows)[rowIndex].Cells[""] as DatePicker).SelectedDate = 
                //    //if (Convert.ToDateTime(_dtAdvancedConfig.Rows[currentRowIndex + 1]["StartDate"].ToString()) < Convert.ToDateTime(e.Cell.Value.ToString()))
                //    //{
                //    //    _dtAdvancedConfig.Rows[currentRowIndex + 1]["StartDate"] = Convert.ToDateTime(_dtAdvancedConfig.Rows[currentRowIndex]["StartDate"]).AddDays(1);
                //    //    UpdateLayout();
                //    //}
                //}
            }
            else if (columnName == "StartDate")
            {
                if (prevIndex >= 0)
                {
                    //if (Convert.ToDateTime(e.Cell.Value) <= Convert.ToDateTime(_dtAdvancedConfig.Rows[prevIndex]["EndDate"]))
                    //{
                    //    //e.Cell.Value = Convert.ToDateTime(_dtAdvancedConfig.Rows[prevIndex]["EndDate"]).AddDays(1) = e.Cell.Value.ToString()).AddDays(-1);
                    //    MessageBox.Show("Start of period cannot be less than end of period of previous year.", "Date Configuration.", MessageBoxButton.OK, MessageBoxImage.Exclamation);
                    //}
                    //else
                    //{
                    //    _dtAdvancedConfig.Rows[prevIndex]["EndDate"] = Convert.ToDateTime(e.Cell.Value.ToString()).AddDays(-1);
                    //}
                    _dtAdvPeriodConfig.Rows[prevIndex]["EndDate"] = Convert.ToDateTime(Helper.GetParsedDate(value, DateFormat.MonthDateYear), CultureInfo.InvariantCulture).AddDays(-1);
                    UpdateLayout();
                    //btnUpdate.Focus();
                }
            }
            else if (columnName == "Label")
            {
                if (prevIndex >= 0)
                {
                    _dtAdvPeriodConfig.Rows[prevIndex]["Label"] = Convert.ToString(value, CultureInfo.InvariantCulture);
                    UpdateLayout();
                }
            }
            //_dtAdvancedConfig.AcceptChanges();
            //SetBtnUpdate();
            //if (e.Cell.Column.Key == "StartDate" || e.Cell.Column.Key == "EndDate")
            //{
            //    if (Convert.ToDateTime(Helper.GetParsedDate(Convert.ToString(e.Cell.Value, CultureInfo.CurrentCulture), DateFormat.MonthDateYear), CultureInfo.InvariantCulture) != Convert.ToDateTime(Helper.GetParsedDate(Convert.ToString(_cellValue, CultureInfo.CurrentCulture), DateFormat.MonthDateYear), CultureInfo.InvariantCulture))
            //    {
            //        btnGeneratePeriods.IsEnabled = true;
            //        if ((AdvDateConfigs.PagerSettings.CurrentPageIndex - 1) >= _noneditablePageStart && (AdvDateConfigs.PagerSettings.CurrentPageIndex - 1) <= _noneditablePageEnd)
            //            Parent.AlertCheck = true;
            //    }
            //}            
        }

        #region "Properties"
        public DataTable AdvDateConfig
        {
            get { return _dtAdvDateConfig; }
            set { _dtAdvDateConfig = value; }
        }
       
        #endregion       
       
    }

    public static class AdvConfigSettings
    {
        public static int year;
    }

    public class MyConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return AdvConfigSettings.year + (int)value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
